using UnityEngine;

namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static void Main()
        {
            //cannon
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Field Cannon",
                    DescriptionOverride = "An artillery piece with a low rate of fire and a high rate of destruction.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb.png"),
                    AfterSpawn = (Instance) =>
                    {

						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("base.png");
						//Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("barrel.png");
						//var barrel = Instance.transform.GetChild(0);
						//barrel.gameObject.FixColliders();
						Instance.FixColliders();

						GameObject Wheel = ModAPI.CreatePhysicalObject("Wheel", ModAPI.LoadSprite("wheel.png"));
						Wheel.transform.SetParent(Instance.transform);
						GameObject.Destroy(Wheel.GetComponent<Collider2D>());
						Wheel.AddComponent<CircleCollider2D>();
						if (Instance.transform.lossyScale.x < 0)
						{
							Wheel.transform.position = (Vector2)Instance.transform.position - new Vector2(1.9f, 0.5f); //Could use localPosition, had this before changing parent.
						}
						else
						{
							Wheel.transform.position = (Vector2)Instance.transform.position - new Vector2(-1.9f, 0.5f); //Could use localPosition, had this before changing parent.
						}
						var Joint = Wheel.AddComponent<HingeJoint2D>();
						Joint.connectedBody = Instance.GetComponent<Rigidbody2D>();
						Joint.enableCollision = false;
						PhysicalBehaviour physicalBehaviour = Wheel.GetComponent<PhysicalBehaviour>();
						physicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Soft");
						physicalBehaviour.OverrideShotSounds = new AudioClip[0];
						physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
						Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
						Wheel.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						//var col = Wheel.AddComponent<NoCollideWithBodyPart>();
						//col.BodyPart = LimbBehaviour.BodyPart.Legs;
						//col.Collider = Wheel.GetComponent<CircleCollider2D>();
						//var col2 = Wheel.AddComponent<NoCollideWithBodyPart>();
						//col2.BodyPart = LimbBehaviour.BodyPart.Torso;
						//col2.Collider = Wheel.GetComponent<CircleCollider2D>();
						//var col3 = Wheel.AddComponent<NoCollideWithBodyPart>();
						//col3.BodyPart = LimbBehaviour.BodyPart.Head;
						//col3.Collider = Wheel.GetComponent<CircleCollider2D>();
						//var col4 = Wheel.AddComponent<NoCollideWithBodyPart>();
						//col4.BodyPart = LimbBehaviour.BodyPart.Arms;
						var E = Wheel.AddComponent<EBikeBehaviour>();
						E.Hinge = Joint;
						E.Speed = -100f;

						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 10f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 10f;

						GameObject cannon = ModAPI.CreatePhysicalObject("cannon", ModAPI.LoadSprite("barrel.png"));
						cannon.transform.SetParent(Instance.transform);
						GameObject.Destroy(cannon.GetComponent<Collider2D>());
						cannon.AddComponent<BoxCollider2D>();
						var Joint2 = cannon.AddComponent<HingeJoint2D>();
						Joint2.connectedBody = Instance.GetComponent<Rigidbody2D>();
						Joint2.enableCollision = false;
						PhysicalBehaviour physicalBehaviour2 = cannon.GetComponent<PhysicalBehaviour>();
						physicalBehaviour2.Properties = ModAPI.FindPhysicalProperties("Metal");

						//physicalBehaviour.OverrideShotSounds = new AudioClip[0];
						if (Instance.transform.lossyScale.x < 0)
						{
							cannon.transform.position = (Vector2)Instance.transform.position - new Vector2(3f, -0.2f); //Could use localPosition, had this before changing parent.
							cannon.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("barrelflop.png");
							Joint2.anchor = new Vector3(1f, 0f);
						}
						else
						{
							cannon.transform.position = (Vector2)Instance.transform.position - new Vector2(-3f, -0.2f); //Could use localPosition, had this before changing parent.
							cannon.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("barrel.png");
							Joint2.anchor = new Vector3(-1f, 0f);
						}
						JointMotor2D motor = new JointMotor2D();
						motor.maxMotorTorque = 50;
						cannon.GetComponent<HingeJoint2D>().motor = motor;
						JointMotor2D motor2 = new JointMotor2D();
						motor2.maxMotorTorque = 10;
						Wheel.GetComponent<HingeJoint2D>().motor = motor2;
						var shoota = cannon.AddComponent<ProjectileLauncherBehaviour>();
						shoota.projectileAsset = ModAPI.FindSpawnable("Field Cannon Round");
						
						if (Instance.transform.lossyScale.x < 0)
						{
							shoota.projectileLaunchStrength = -25f;
							shoota.barrelPosition = new Vector2(-0f, 0f);
						}
						else
						{
							shoota.projectileLaunchStrength = 25f;
							shoota.barrelPosition = new Vector2(0f, 0f);
						}
						//physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)
								Physics2D.IgnoreCollision(a, b);
					}
                }
        );

			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Red Barrel"),
					NameOverride = "Field Cannon Round",
					DescriptionOverride = "A highly fragile explosive round.",
					CategoryOverride = ModAPI.FindCategory("Explosives"),
					ThumbnailOverride = ModAPI.LoadSprite("thumb2.png"),
					AfterSpawn = (Instance) =>
					{
						foreach (UnityEngine.Object component in Instance.GetComponents<Collider2D>())
							UnityEngine.Object.Destroy(component);
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("blingus.png");
						Instance.AddComponent<BoxCollider2D>();
						Instance.GetComponent<ExplosiveBehaviour>().Range = 3f;
						Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 1f;
						Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 40;
						Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 4f;
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
						Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.1f;
						Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 5f;
						Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 3f;
					}
				}
			);

		}
    }
}
